Ruby: pm_call_node Struct Reference

Ruby 3.4.7p58 (2025-10-08 revision 7a5688e2a27668e48f8d6ff4af5b2208b98a2f5e)

Data Fields
pm_call_node Struct Reference

CallNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_node * | receiver
| CallNode#receiver.
pm_location_t | call_operator_loc
| CallNode#call_operator_loc.
pm_constant_id_t | name
| CallNode#name.
pm_location_t | message_loc
| CallNode#message_loc.
pm_location_t | opening_loc
| CallNode#opening_loc.
struct pm_arguments_node * | arguments
| CallNode#arguments.
pm_location_t | closing_loc
| CallNode#closing_loc.
struct pm_node * | block
| CallNode#block.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

CallNode.

Represents a method call, in all of the various forms that can take.

    foo
    ^^^

    foo()
    ^^^^^

    +foo
    ^^^^

    foo + bar
    ^^^^^^^^^

    foo.bar
    ^^^^^^^

    foo&.bar
    ^^^^^^^^

Type: ::PM_CALL_NODE

Flags (#pm_call_node_flags):

- ::PM_CALL_NODE_FLAGS_SAFE_NAVIGATION
- ::PM_CALL_NODE_FLAGS_VARIABLE_CALL
- ::PM_CALL_NODE_FLAGS_ATTRIBUTE_WRITE
- ::PM_CALL_NODE_FLAGS_IGNORE_VISIBILITY

Definition at line 2129 of file ast.h.

## Field Documentation

## ◆ arguments

struct pm_arguments_node* pm_call_node::arguments

CallNode#arguments.

Represents the arguments to the method call. These can be any non-void expressions.

    foo(bar)
        ^^^

Definition at line 2200 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ base

pm_node_t pm_call_node::base

The embedded base node.

Definition at line 2131 of file ast.h.

Referenced by pm_dump_json().

## ◆ block

struct pm_node* pm_call_node::block

CallNode#block.

Represents the block that is being passed to the method.

    foo { |a| a }
        ^^^^^^^^^

Definition at line 2220 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ call_operator_loc

pm_location_t pm_call_node::call_operator_loc

CallNode#call_operator_loc.

Represents the location of the call operator.

    foo.bar
       ^

    foo&.bar
       ^^

Definition at line 2161 of file ast.h.

Referenced by pm_dump_json().

## ◆ closing_loc

pm_location_t pm_call_node::closing_loc

CallNode#closing_loc.

Represents the location of the right parenthesis.

    foo(bar)
           ^

Definition at line 2210 of file ast.h.

Referenced by pm_dump_json().

## ◆ message_loc

pm_location_t pm_call_node::message_loc

CallNode#message_loc.

Represents the location of the message.

    foo.bar
        ^^^

Definition at line 2181 of file ast.h.

Referenced by pm_dump_json().

## ◆ name

pm_constant_id_t pm_call_node::name

CallNode#name.

Represents the name of the method being called.

    foo.bar # name `:foo`
    ^^^

Definition at line 2171 of file ast.h.

Referenced by pm_dump_json().

## ◆ opening_loc

pm_location_t pm_call_node::opening_loc

CallNode#opening_loc.

Represents the location of the left parenthesis. foo(bar) ^

Definition at line 2190 of file ast.h.

Referenced by pm_dump_json().

## ◆ receiver

struct pm_node* pm_call_node::receiver

CallNode#receiver.

The object that the method is being called on. This can be either nil or any non-void expression.

    foo.bar
    ^^^

    +foo
     ^^^

    foo + bar
    ^^^

Definition at line 2148 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h